//+------------------------------------------------------------------+
//|                                             MY TRAILING STOP.mq4 |
//|                      Copyright  2010, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"
/*
Check if there is an open position for the currency of the chart in question.
if the difference between ask/bid price and order open price is 10 pips set the position close marker at 7
leave the postion marker at 7 till pip difference is 12
After 12 follow with marker 5 pips away till position is closed.
After 25 follow with marker 7 pips away till position is closed.

*/
//----------------------Variables for Trailing Stop---------------------

extern double lots = 0.1;                    //Lot Size
extern int FirstSetPoint=10;                 //LeadFirst
extern int SecondSetPoint=12;                //LeadSecond
extern int ThirdSetPoint=25;                 //LeadThird
extern int FirstTrailPoint=5;                //TrailFirst
extern int SecondTrailPoint=5;               //TrailSecond
extern int ThirdTrailPoint=7;                //TrailThird
extern int FloatingTrailPoint=7;             //Order Close Marker
extern int OrderClosePoint=7;                //Order Close Marker 2
extern bool CloseOrderFlag = false;
extern int  InProfitTicks = 10;
int total, i, PriceDifference, m=0;

//---------------------Variables for Stop Loss----------------------------

extern int n = 0;
extern int StopLoss = 20;
extern int InLossTicks = 6;


//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
 
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//--------Finding the correct trade for trailing stop

 total = OrdersTotal();
 
 
      for(i = 0; i < total; i++)
{
         OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
         
         if(OrderSymbol() != Symbol())  continue;  
         
         
  //--------- Trailing Stop on a Buy Order  
   
      
         if(OrderType() == OP_BUY)    
   {    
     
          PriceDifference = ((Bid - OrderOpenPrice())/Point)/10; Print(Symbol(),"  ","Buy","   ",OrderClosePoint,"   ",CloseOrderFlag,"  ",PriceDifference,"  ",FloatingTrailPoint,"  ",n);        
  
  
         if (PriceDifference <= OrderClosePoint && CloseOrderFlag == true)
            { m = m+1;}
             else
              {m = 0;}
              
    {  
        if(m >= InProfitTicks){ OrderClose(OrderTicket(),lots,Bid,3,Green); OrderClosePoint =7; CloseOrderFlag = false;  }
           
      {
            if (PriceDifference >= FirstSetPoint && PriceDifference <= SecondSetPoint) 
               {FloatingTrailPoint = FirstTrailPoint; CloseOrderFlag = true; }
              
         {
               if (PriceDifference > SecondSetPoint && PriceDifference <= ThirdSetPoint) {FloatingTrailPoint = PriceDifference - SecondTrailPoint; CloseOrderFlag = true;} 
                  
             {
                  if (PriceDifference > ThirdSetPoint) { FloatingTrailPoint = PriceDifference - ThirdTrailPoint; CloseOrderFlag = true;}           
               {      
                      if (FloatingTrailPoint > OrderClosePoint)  {OrderClosePoint=FloatingTrailPoint;}
                       
                     }
                     
                  }
               }        
         
           }
         
     }                  
}

//------------------ Trailing Stop on a Sell Order

 if(OrderType() == OP_SELL)    
   {    
       
          PriceDifference = ((OrderOpenPrice() - Ask)/Point)/10; Print(Symbol()," ","Sell","   ",OrderClosePoint,"   ",CloseOrderFlag,"  ",PriceDifference,"  ",FloatingTrailPoint,"  ",n);      
          
  
         if (PriceDifference <= OrderClosePoint && CloseOrderFlag == true)
            { m = m+1;}
             else
              {m = 0;}
         
       {  
         
         
         if(m >= InProfitTicks) {  OrderClose(OrderTicket(),lots,Ask,3,Green); OrderClosePoint =7; CloseOrderFlag = false;  }
           
      {
            if (PriceDifference >= FirstSetPoint && PriceDifference <= SecondSetPoint) {FloatingTrailPoint = FirstTrailPoint; CloseOrderFlag = true; }
              
         {
               if (PriceDifference > SecondSetPoint && PriceDifference <= ThirdSetPoint) {FloatingTrailPoint = PriceDifference - SecondTrailPoint; CloseOrderFlag = true;} 
                  
             {
                  if (PriceDifference > ThirdSetPoint) { FloatingTrailPoint = PriceDifference - ThirdTrailPoint; CloseOrderFlag = true;}           
               {      
                      if (FloatingTrailPoint > OrderClosePoint)  {OrderClosePoint=FloatingTrailPoint;}
                       
          
                     
                  }
               }        
              }
           }
         
     }      
}
//------------------------------------Stop Loss----------------------------------------

     
         if(PriceDifference <= -StopLoss) {n = n+1;}
            else {n = 0;}
         
             if(n >= InLossTicks && OrderType() == OP_BUY ) 
               {  OrderClose(OrderTicket(),lots,Bid,3,Red); OrderClosePoint =7; CloseOrderFlag = false;  }
               
             if(n >= InLossTicks && OrderType() == OP_SELL )
               {  OrderClose(OrderTicket(),lots,Ask,3,Red); OrderClosePoint =7; CloseOrderFlag = false;  }
             
  
       
  
         
   
 }  

   
   
      
//----
   return(0);
  }
//+------------------------------------------------------------------+